pbsdsh(1B)

NAME
pbsdsh - distribute tasks to vnodes under PBS

SYNOPSIS
pbsdsh [-c <copies>] [-s] [-v] [-o] -- <program> [<program args>]
pbsdsh [-n <vnode index>] [-s] [-v] [-o] -- <program> [<program args>]
pbsdsh --version

DESCRIPTION
The pbsdsh command allows you to distribute and execute a task on each of the vnodes assigned to your job by executing (spawning) the application on each vnode. The pbsdsh command uses the PBS Task Manager, or TM, to distribute the program on the allocated vnodes. When run without the -c or the -n option, pbsdsh will spawn the program on all vnodes allocated to the PBS job. The spawns take place concurrently; all execute at (about) the same time. Note that the double dash must come after the options and before the program and arguments. The double dash is only required for Linux. The pbsdsh command runs one task for each line in the $PBS_NODEFILE. Each MPI rank gets a single line in the $PBS_NODEFILE, so if you are running multiple MPI ranks on the same host, you still get multiple pbsdsh tasks on that host. Example
The following example shows the pbsdsh command inside of a PBS batch job. The options indicate that the user wants pbsdsh to run the myapp program with one argument (app-arg1) on all four vnodes allocated to the job (i.e. the default behavior).
    #!/bin/sh
    #PBS -l select=4:ncpus=1
    #PBS -l walltime=1:00:00 pbsdsh ./myapp app-arg1

OPTIONS

-c copies
    The program is spawned copies times on the vnodes allocated, one per vnode, unless copies is greater than the number of vnodes. If copies is greater than the number of vnodes, it wraps around, running multiple instances on some vnodes. This option is mutually exclusive with -n.

-n <vnode index>
    The program is spawned only on a single vnode, which is the vnode index -th vnode allocated. This option is mutually exclusive with -c.

-o  No obit request is made for spawned tasks. The program does not wait for the tasks to finish.

-s  Te program is run in turn on each vnode, one after the other.

-v  Produces verbose output about error conditions and task exit status.

--version
    The pbsdsh command returns its PBS version information and exits. This option can only be used alone

OPERANDS

program
    The first operand, program , is the program to execute. The double dash must precede the program under Linux.

program args
    Additional operands, program args , are passed as arguments to the program.

STANDARD ERROR
The pbsdsh command writes a diagnostic message to standard error for each error occurrence.

SEE ALSO
The PBS Professional User's Guide, the PBS Professional Administrator's Guide, qsub(1B), tm(3).